routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Auth::routes();

// TODO : user not connected
Route::post('/users/{user}/finish', 'UsersController@storeFinish')->name('users.finish');
Route::get('/users/{user}/finish', 'UsersController@finish');

/* User connected */
Route::middleware(['auth'])->group(function () {
    Route::get('/', 'HomeController@index');

    Route::resource('probes', 'ProbesController')->only(['index', 'show']);
    Route::resource('plants', 'PlantsController')->only(['index', 'show']);
});

/* Admin */
Route::middleware(['auth', 'admin'])->group(function () {
    Route::resource('users', 'UsersController')->only(['index', 'store']);
    Route::resource('probes', 'ProbesController')->only(['store']);
    Route::resource('plants', 'PlantsController')->only(['store', 'destroy']);
});

app/User.php
<?php

namespace App;

use Illuminate\Notifications\Notifiable;
use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Foundation\Auth\User as Authenticatable;

class User extends Authenticatable
{
    use Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name', 'email', 'admin', 'city'
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password', 'remember_token',
    ];

    /**
     * Get probes of user.
     */
    public function probes()
    {
        return $this->hasMany('App\Probe');
    }

}

app/Http/Controllers/UsersController.php
<?php

namespace App\Http\Controllers;

use App\Mail\FinishAccount;
use Illuminate\Http\Request;
use App\User;
use App\Probe;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Mail;

class UsersController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $users = User::all();
        return view('users.index', compact('users'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $request->validate([
            'name' => ['required', 'string', 'max:255'],
            'email' => ['required', 'string', 'email', 'max:255', 'unique:users'],
            'admin' => ['required', 'boolean'],
            'city' => ['required', 'string', 'max:255'],
        ]);

        $user = User::create([
            'name' => $request->name,
            'email' => $request->email,
            'admin' => $request->admin,
            'city' => $request->city
        ]);

        Mail::to($user->email)->send(new FinishAccount($user));

        return redirect(route('users.index'))->with('success', 'Utilisateur créé avec succès');
    }

    public function finish(User $user){
        if (!$user->password == null){
            return redirect('/')->with('error', "Ce compte est déjà finalisé");
        }

        return view('users.validate', compact('user'));
    }

    public function storeFinish(Request $request, User $user){
        $request->validate([
            'password' => ['required', 'string', 'min:8', 'confirmed'],
        ]);

        $user->password = Hash::make($request->password);
        $user->active = 1;
        $user->save();

        // Connexion automatique de l'utilisateur
        Auth::guard()->login($user);

        // Redirection sur la page d'accueil
        return redirect('/');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}

resources/views/users/index.blade.php
@extends('layouts.app')

@section('content')

    <div class="card">
        <div class="card-header">
            <h3 class="card-title">Utilisateurs</h3>

            <div class="card-tools">
                <!-- Button trigger modal -->
                <button type="button" class="btn btn-primary btn-sm" data-toggle="modal"
                        data-target="#modal-create-user">
                    Nouvel utilisateur
                </button>
            </div>
        </div>
        <!-- /.card-header -->
        <div class="card-body p-0">
            <table class="table">
                <thead>
                <tr>
                    <th style="width: 10px">#</th>
                    <th>Name</th>
                    <th>Email</th>
                    <th>City</th>
                    <th>Group</th>
                    <th>Status</th>
                </tr>
                </thead>
                <tbody>

                @foreach($users as $user)

                    <tr>
                        <td>{{$user->id}}</td>
                        <td>{{$user->name}}</td>
                        <td>{{$user->email}}</td>
                        <td>{{$user->city}}</td>
                        <td><span class="right badge badge-info">{{$user->admin ? 'Admin' : 'User'}}</span></td>
                        <td>
                            @if($user->active)
                                <span class="right badge badge-success">Active</span>
                            @else
                                <span class="right badge badge-danger">Inactive</span>
                            @endif
                        </td>
                    </tr>

                @endforeach
                </tbody>
            </table>
        </div>
        <!-- /.card-body -->
    </div>


    <!-- Modal -->
    <div class="modal fade" id="modal-create-user" tabindex="-1" role="dialog" aria-labelledby="modal-create-user">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h4 class="modal-title">Créer un utilisateur</h4>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">×</span>
                    </button>
                </div>
                <form action="{{ route('users.store') }}" method="post">
                    @csrf
                    <div class="modal-body">
                        <div class="form-group">
                            <label for="name">Name</label>
                            <input type="text" name="name" id="name"
                                   class="form-control @error('name') is-invalid @enderror" placeholder="Enter name"
                                   value="{{ old('name') }}" required>
                            @error('name')
                            <span class="invalid-feedback" role="alert">
                        <strong>{{ $message }}</strong>
                    </span>
                            @enderror
                        </div>

                        <div class="form-group">
                            <label for="email">Email address</label>
                            <input type="email" name="email" id="email"
                                   class="form-control @error('email') is-invalid @enderror" placeholder="Enter email"
                                   value="{{ old('email') }}" required>
                            @error('email')
                            <span class="invalid-feedback" role="alert">
                        <strong>{{ $message }}</strong>
                    </span>
                            @enderror
                        </div>

                        {{-- TODO : gestion des erreurs --}}
                        <div class="form-group">
                            <label>Rôle</label>
                            <select class="form-control" name="admin" id="admin">
                                <option value="0">Utilisateur</option>
                                <option value="1">Administrateur</option>
                            </select>
                        </div>

                        <div class="form-group">
                            <label for="city">City</label>
                            <input type="text" name="city" id="city"
                                   class="form-control @error('city') is-invalid @enderror" placeholder="Enter city"
                                   value="{{ old('city') }}" required>
                            @error('city')
                            <span class="invalid-feedback" role="alert">
                        <strong>{{ $message }}</strong>
                    </span>
                            @enderror
                        </div>

                    </div>
                    <div class="modal-footer">
                        <button type="submit" class="btn btn-primary">Créer</button>
                    </div>
                </form>
            </div>
        </div>
    </div>

@endsection

resources/views/users/validate.blade.php
@extends('layouts.login')

@section('content')
    <div class="card">
        <div class="card-body login-card-body">
            <p class="login-box-msg">{{ __('Création du mot de passe') }}</p>

            <form method="POST" action="{{ route('users.finish', $user) }}">
                @csrf

                <div class="input-group mb-3">
                    <input id="name" type="text" class="form-control" name="name" disabled value="{{$user->name}}">
                    <div class="input-group-append">
                        <div class="input-group-text">
                            <span class="fas fa-user"></span>
                        </div>
                    </div>
                </div>

                <div class="input-group mb-3">
                    <input type="password" class="form-control @error('password') is-invalid @enderror"
                           placeholder="{{ __('Password') }}" name="password" required autocomplete="current-password">
                    <div class="input-group-append">
                        <div class="input-group-text">
                            <span class="fas fa-lock"></span>
                        </div>
                    </div>
                </div>
                @error('password')
                <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                @enderror

                <div class="input-group mb-3">
                    <input type="password" class="form-control @error('password') is-invalid @enderror"
                           placeholder="{{ __('Confirm Password') }}" name="password_confirmation" required autocomplete="new-password">
                    <div class="input-group-append">
                        <div class="input-group-text">
                            <span class="fas fa-lock"></span>
                        </div>
                    </div>
                </div>
                @error('password')
                <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                @enderror

                <div class="row">
                    <div class="col-5">

                    </div>
                    <!-- /.col -->
                    <div class="col-7">
                        <button type="submit" class="btn btn-primary btn-block">Finaliser l'inscription</button>
                    </div>
                    <!-- /.col -->
                </div>

            </form>
        </div>
    </div>

@endsection